"""
Django settings for openpaper project.

Generated by 'django-admin startproject' using Django 1.10.2.

For more information on this file, see
https://docs.djangoproject.com/en/1.10/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.10/ref/settings/
"""

import os
import sys

from django.utils.translation import gettext_lazy as _

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
sys.stderr.write(f"__file__={__file__}\n")
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
sys.stderr.write(f"BASE_DIR={BASE_DIR}\n")

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.10/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'p_yx+bt&1v@1jrh(+7jl(nz_px1c$9spzj+knwj_%%ju@xel50'

HASH_SALT = "hereissomerandomhashsalt"

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = [
    'openpaper.work',
    'web',
]

NO_HTTPS = False

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.humanize',
    'django.contrib.messages',
    'django.contrib.sessions',
    'django.contrib.sitemaps',
    'django.contrib.sites',
    'django.contrib.staticfiles',

    # contrib
    'rest_framework',
    'rest_framework_api_key',

    # Openpaper
    'openpaper',
    'openpaper.backend',
    'openpaper.beacon',
    'openpaper.dashboard',
    'openpaper.home',
    'openpaper.scannerdb',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',  # default
                'django.template.context_processors.request',  # default
                'django.contrib.auth.context_processors.auth',  # default
                # default
                'django.contrib.messages.context_processors.messages',
                'django.template.context_processors.i18n',  # default
                'django.template.context_processors.media',  # default
                'django.template.context_processors.static',  # default
            ],
            'loaders': [
                ('django.template.loaders.cached.Loader', [
                    'django.template.loaders.filesystem.Loader',
                    'django.template.loaders.app_directories.Loader',
                ]),
            ],
            'debug': True,
        },
        'DIRS': [
            # required to override some templates from some apps
            os.path.join(BASE_DIR, 'openpaper', 'templates'),
        ],
    },
]
sys.stderr.write(f"TEMPLATES[0]['DIRS']={TEMPLATES[0]['DIRS']}\n")

SITE_ID = 1

ROOT_URLCONF = 'openpaper.urls'

WSGI_APPLICATION = 'openpaper.wsgi.application'

USE_I18N = True

USE_L10N = True

# keep connections MariaDB open and reuse them
CONN_MAX_AGE = 60  # seconds


# Database
# https://docs.djangoproject.com/en/1.10/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}

REDIS_HOSTS = ['cache']

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.redis.RedisCache',
        'LOCATION': [f'redis://{h}:6379' for h in REDIS_HOSTS],
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.10/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME':
        'django.contrib.auth.password_validation.'
        'UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.'
        'MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.'
        'CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.'
        'NumericPasswordValidator',
    },
]


REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': (),
    "DEFAULT_PERMISSION_CLASSES": [
        "openpaper.api.permissions.ReadOnly",
    ],
    'DEFAULT_PAGINATION_CLASS': (
        'rest_framework.pagination.PageNumberPagination'
    ),
    'PAGE_SIZE': 50,
}


# Internationalization
# https://docs.djangoproject.com/en/1.10/topics/i18n/

LANGUAGE_CODE = 'en'

LANGUAGES = (
    ('de', _("German")),
    ('fr', _("French")),
    ('en', _("English")),
    ('zh-hans', _("Simplified Chinese")),
)
LOCALE_PATHS = [os.path.join(BASE_DIR, "l10n")]
sys.stderr.write(f"LOCALE_PATHS={LOCALE_PATHS}\n")

TIME_ZONE = 'UTC'
USE_I18N = True
USE_L10N = True
USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.10/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'collected')
sys.stderr.write(f"STATIC_ROOT={STATIC_ROOT}\n")
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "node_modules", "chart.js", "dist"),
    os.path.join(BASE_DIR, "static"),
]
sys.stderr.write(f"STATICFILES_DIRS={STATICFILES_DIRS}\n")

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
)

ACCOUNT_ACTIVATION_DAYS = 2
REGISTRATION_OPEN = False
INCLUDE_AUTH_URLS = True
INCLUDE_REGISTER_URL = True

PASSWORD_RESET_TIMEOUT_DAYS = 2
EMAIL_CHANGE_TIMEOUT_DAYS = 2

MAILQUEUE_CELERY = False
MAILQUEUE_QUEUE_UP = False

NO_REPLY_EMAIL = "jflesch@openpaper.work"
EXTRA_INSTALLED_APPS = []

DATA_UPLOAD_MAX_MEMORY_SIZE = 64 * 1024 * 1024

DEFAULT_AUTO_FIELD = 'django.db.models.AutoField'

RABBITMQ_HOST = 'msgqueue'

if os.path.exists(os.path.join(
            BASE_DIR, "openpaper", "local_settings.py"
        )):
    from openpaper.local_settings import *  # noqa: F403, F401

REGISTRATION_DEFAULT_FROM_EMAIL = NO_REPLY_EMAIL
DEFAULT_FROM_EMAIL = NO_REPLY_EMAIL
INSTALLED_APPS += EXTRA_INSTALLED_APPS
TEMPLATES[0]['OPTIONS'].update(TEMPLATE_OPTIONS)  # noqa: F405
